
#ifndef _VOLUTIL_
#define _VOLUTIL_

/* DO NOT EDIT: generated by rp2gen from volutil.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif
#include <rpc2/rpc2.h>
#include <rpc2/se.h>
#include <rpc2/errors.h>
#ifdef __cplusplus
}
#endif

 /* BLURB lgpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2008 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the  terms of the  GNU  Library General Public Licence  Version 2,  as
shown in the file LICENSE. The technical and financial contributors to
Coda are listed in the file CREDITS.

                        Additional copyrights
                           none currently

#*/

#define UTIL_SUBSYSID	7777
#define VolTKFile	"db/volutil.tk"
#ifndef _vcrcommon_rpc2_
#define _vcrcommon_rpc2_
#include "vcrcommon.h"
#endif /* _vcrcommon_rpc2_ */

typedef struct RVMSize_data {
    RPC2_Integer nLargeVnodes;
    RPC2_Integer nSmallVnodes;
    RPC2_Integer DirPagesSize;
    RPC2_Integer LargeVnodeSize;
    RPC2_Integer SmallVnodeSize;
    RPC2_Integer VolumeSize;
} RVMSize_data;

typedef struct VolDumpEstimates {
    RPC2_Unsigned Lvl0;
    RPC2_Unsigned Lvl1;
    RPC2_Unsigned Lvl2;
    RPC2_Unsigned Lvl3;
    RPC2_Unsigned Lvl4;
    RPC2_Unsigned Lvl5;
    RPC2_Unsigned Lvl6;
    RPC2_Unsigned Lvl7;
    RPC2_Unsigned Lvl8;
    RPC2_Unsigned Lvl9;
} VolDumpEstimates;

#define volUtil_HEAD_VERSION	1375508649

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif /* _STUB_PREDEFINED_ */

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long volUtil_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

long VolSalvage(RPC2_Handle cid, RPC2_String partition, RPC2_Unsigned VolumeNumber, RPC2_Integer force, RPC2_Integer debug, RPC2_Integer list);
long S_VolSalvage(RPC2_Handle cid, RPC2_String partition, RPC2_Unsigned VolumeNumber, RPC2_Integer force, RPC2_Integer debug, RPC2_Integer list);
#define VolSalvage_OP	1
extern ARG VolSalvage_ARGS[];
#define VolSalvage_PTR	VolSalvage_ARGS

long VolCreate(RPC2_Handle cid, RPC2_String partition, RPC2_String volname, VolumeId *volid, RPC2_Integer repvol, VolumeId grpid);
long S_VolCreate(RPC2_Handle cid, RPC2_String partition, RPC2_String volname, VolumeId *volid, RPC2_Integer repvol, VolumeId grpid);
#define VolCreate_OP	2
extern ARG VolCreate_ARGS[];
#define VolCreate_PTR	VolCreate_ARGS

long VolInfo(RPC2_Handle cid, RPC2_String volname, RPC2_Integer all, SE_Descriptor *sed);
long S_VolInfo(RPC2_Handle cid, RPC2_String volname, RPC2_Integer all, SE_Descriptor *sed);
#define VolInfo_OP	3
extern ARG VolInfo_ARGS[];
#define VolInfo_PTR	VolInfo_ARGS

long VolMakeVLDB(RPC2_Handle cid, RPC2_String infile);
long S_VolMakeVLDB(RPC2_Handle cid, RPC2_String infile);
#define VolMakeVLDB_OP	4
extern ARG VolMakeVLDB_ARGS[];
#define VolMakeVLDB_PTR	VolMakeVLDB_ARGS

long VolMakeVRDB(RPC2_Handle cid, RPC2_String infile);
long S_VolMakeVRDB(RPC2_Handle cid, RPC2_String infile);
#define VolMakeVRDB_OP	5
extern ARG VolMakeVRDB_ARGS[];
#define VolMakeVRDB_PTR	VolMakeVRDB_ARGS

long VolShowVnode(RPC2_Handle cid, RPC2_Unsigned volnumber, RPC2_Unsigned vnodeNumber, RPC2_Unsigned unique, SE_Descriptor *sed);
long S_VolShowVnode(RPC2_Handle cid, RPC2_Unsigned volnumber, RPC2_Unsigned vnodeNumber, RPC2_Unsigned unique, SE_Descriptor *sed);
#define VolShowVnode_OP	6
extern ARG VolShowVnode_ARGS[];
#define VolShowVnode_PTR	VolShowVnode_ARGS

long VolSetVV(RPC2_Handle cid, RPC2_Unsigned volnumber, RPC2_Unsigned vnodeNumber, RPC2_Unsigned unique, ViceVersionVector *vv);
long S_VolSetVV(RPC2_Handle cid, RPC2_Unsigned volnumber, RPC2_Unsigned vnodeNumber, RPC2_Unsigned unique, ViceVersionVector *vv);
#define VolSetVV_OP	7
extern ARG VolSetVV_ARGS[];
#define VolSetVV_PTR	VolSetVV_ARGS

long VolPurge(RPC2_Handle cid, RPC2_Unsigned volid, RPC2_String volname);
long S_VolPurge(RPC2_Handle cid, RPC2_Unsigned volid, RPC2_String volname);
#define VolPurge_OP	8
extern ARG VolPurge_ARGS[];
#define VolPurge_PTR	VolPurge_ARGS

long VolLookup(RPC2_Handle cid, RPC2_String vol, SE_Descriptor *sed);
long S_VolLookup(RPC2_Handle cid, RPC2_String vol, SE_Descriptor *sed);
#define VolLookup_OP	9
extern ARG VolLookup_ARGS[];
#define VolLookup_PTR	VolLookup_ARGS

long VolUpdateDB(RPC2_Handle cid);
long S_VolUpdateDB(RPC2_Handle cid);
#define VolUpdateDB_OP	10
extern ARG VolUpdateDB_ARGS[];
#define VolUpdateDB_PTR	VolUpdateDB_ARGS

long VolShutdown(RPC2_Handle cid);
long S_VolShutdown(RPC2_Handle cid);
#define VolShutdown_OP	11
extern ARG VolShutdown_ARGS[];
#define VolShutdown_PTR	VolShutdown_ARGS

long VolSwaplog(RPC2_Handle cid);
long S_VolSwaplog(RPC2_Handle cid);
#define VolSwaplog_OP	12
extern ARG VolSwaplog_ARGS[];
#define VolSwaplog_PTR	VolSwaplog_ARGS

long VolSetDebug(RPC2_Handle cid, RPC2_Integer debuglevel);
long S_VolSetDebug(RPC2_Handle cid, RPC2_Integer debuglevel);
#define VolSetDebug_OP	13
extern ARG VolSetDebug_ARGS[];
#define VolSetDebug_PTR	VolSetDebug_ARGS

long VolDumpEstimate(RPC2_Handle cid, RPC2_Unsigned volid, VolDumpEstimates *sizes);
long S_VolDumpEstimate(RPC2_Handle cid, RPC2_Unsigned volid, VolDumpEstimates *sizes);
#define VolDumpEstimate_OP	14
extern ARG VolDumpEstimate_ARGS[];
#define VolDumpEstimate_PTR	VolDumpEstimate_ARGS

long VolNewDump(RPC2_Handle cid, RPC2_Unsigned volid, RPC2_Integer *Incremental);
long S_VolNewDump(RPC2_Handle cid, RPC2_Unsigned volid, RPC2_Integer *Incremental);
#define VolNewDump_OP	15
extern ARG VolNewDump_ARGS[];
#define VolNewDump_PTR	VolNewDump_ARGS

long VolClone(RPC2_Handle cid, RPC2_Unsigned ovolid, RPC2_String newvolname, RPC2_Unsigned *cloneId);
long S_VolClone(RPC2_Handle cid, RPC2_Unsigned ovolid, RPC2_String newvolname, RPC2_Unsigned *cloneId);
#define VolClone_OP	16
extern ARG VolClone_ARGS[];
#define VolClone_PTR	VolClone_ARGS

long VolRestore(RPC2_Handle cid, RPC2_String partname, RPC2_String volname, RPC2_Unsigned *volid);
long S_VolRestore(RPC2_Handle cid, RPC2_String partname, RPC2_String volname, RPC2_Unsigned *volid);
#define VolRestore_OP	17
extern ARG VolRestore_ARGS[];
#define VolRestore_PTR	VolRestore_ARGS

long VolMerge(RPC2_Handle cid);
long S_VolMerge(RPC2_Handle cid);
#define VolMerge_OP	18
extern ARG VolMerge_ARGS[];
#define VolMerge_PTR	VolMerge_ARGS

long VolMakeBackups(RPC2_Handle cid, VolumeId Vid, VolumeId *BackupVid);
long S_VolMakeBackups(RPC2_Handle cid, VolumeId Vid, VolumeId *BackupVid);
#define VolMakeBackups_OP	19
extern ARG VolMakeBackups_ARGS[];
#define VolMakeBackups_PTR	VolMakeBackups_ARGS

long VolMarkAsAncient(RPC2_Handle cid, VolumeId GroupId, VolumeId RepId);
long S_VolMarkAsAncient(RPC2_Handle cid, VolumeId GroupId, VolumeId RepId);
#define VolMarkAsAncient_OP	20
extern ARG VolMarkAsAncient_ARGS[];
#define VolMarkAsAncient_PTR	VolMarkAsAncient_ARGS

long VolDumpMem(RPC2_Handle cid, RPC2_String filename, RPC2_Unsigned address, RPC2_Unsigned size);
long S_VolDumpMem(RPC2_Handle cid, RPC2_String filename, RPC2_Unsigned address, RPC2_Unsigned size);
#define VolDumpMem_OP	21
extern ARG VolDumpMem_ARGS[];
#define VolDumpMem_PTR	VolDumpMem_ARGS

long VolLock(RPC2_Handle cid, VolumeId Vid, ViceVersionVector *VolVV);
long S_VolLock(RPC2_Handle cid, VolumeId Vid, ViceVersionVector *VolVV);
#define VolLock_OP	22
extern ARG VolLock_ARGS[];
#define VolLock_PTR	VolLock_ARGS

long VolUnlock(RPC2_Handle cid, VolumeId Vid);
long S_VolUnlock(RPC2_Handle cid, VolumeId Vid);
#define VolUnlock_OP	23
extern ARG VolUnlock_ARGS[];
#define VolUnlock_PTR	VolUnlock_ARGS

long VolRVMSize(RPC2_Handle cid, VolumeId VolID, RVMSize_data *data);
long S_VolRVMSize(RPC2_Handle cid, VolumeId VolID, RVMSize_data *data);
#define VolRVMSize_OP	24
extern ARG VolRVMSize_ARGS[];
#define VolRVMSize_PTR	VolRVMSize_ARGS

long VolSetLogParms(RPC2_Handle cid, VolumeId Vid, RPC2_Integer OnFlag, RPC2_Integer maxentries);
long S_VolSetLogParms(RPC2_Handle cid, VolumeId Vid, RPC2_Integer OnFlag, RPC2_Integer maxentries);
#define VolSetLogParms_OP	25
extern ARG VolSetLogParms_ARGS[];
#define VolSetLogParms_PTR	VolSetLogParms_ARGS

long VolTiming(RPC2_Handle cid, RPC2_Integer on, SE_Descriptor *sed);
long S_VolTiming(RPC2_Handle cid, RPC2_Integer on, SE_Descriptor *sed);
#define VolTiming_OP	26
extern ARG VolTiming_ARGS[];
#define VolTiming_PTR	VolTiming_ARGS

long PrintStats(RPC2_Handle cid, SE_Descriptor *sed);
long S_PrintStats(RPC2_Handle cid, SE_Descriptor *sed);
#define PrintStats_OP	28
extern ARG PrintStats_ARGS[];
#define PrintStats_PTR	PrintStats_ARGS

long TraceRpc(RPC2_Handle cid, SE_Descriptor *sed);
long S_TraceRpc(RPC2_Handle cid, SE_Descriptor *sed);
#define TraceRpc_OP	29
extern ARG TraceRpc_ARGS[];
#define TraceRpc_PTR	TraceRpc_ARGS

long ShowCallbacks(RPC2_Handle cid, ViceFid *fid, SE_Descriptor *sed);
long S_ShowCallbacks(RPC2_Handle cid, ViceFid *fid, SE_Descriptor *sed);
#define ShowCallbacks_OP	30
extern ARG ShowCallbacks_ARGS[];
#define ShowCallbacks_PTR	ShowCallbacks_ARGS

long TruncateRVMLog(RPC2_Handle cid);
long S_TruncateRVMLog(RPC2_Handle cid);
#define TruncateRVMLog_OP	31
extern ARG TruncateRVMLog_ARGS[];
#define TruncateRVMLog_PTR	TruncateRVMLog_ARGS

long VolGetMaxVolId(RPC2_Handle cid, RPC2_Integer *maxid);
long S_VolGetMaxVolId(RPC2_Handle cid, RPC2_Integer *maxid);
#define VolGetMaxVolId_OP	32
extern ARG VolGetMaxVolId_ARGS[];
#define VolGetMaxVolId_PTR	VolGetMaxVolId_ARGS

long VolSetMaxVolId(RPC2_Handle cid, RPC2_Integer newid);
long S_VolSetMaxVolId(RPC2_Handle cid, RPC2_Integer newid);
#define VolSetMaxVolId_OP	33
extern ARG VolSetMaxVolId_ARGS[];
#define VolSetMaxVolId_PTR	VolSetMaxVolId_ARGS

long VolPeekInt(RPC2_Handle cid, RPC2_String address, RPC2_Integer *pvalue);
long S_VolPeekInt(RPC2_Handle cid, RPC2_String address, RPC2_Integer *pvalue);
#define VolPeekInt_OP	34
extern ARG VolPeekInt_ARGS[];
#define VolPeekInt_PTR	VolPeekInt_ARGS

long VolPokeInt(RPC2_Handle cid, RPC2_String address, RPC2_Integer value);
long S_VolPokeInt(RPC2_Handle cid, RPC2_String address, RPC2_Integer value);
#define VolPokeInt_OP	35
extern ARG VolPokeInt_ARGS[];
#define VolPokeInt_PTR	VolPokeInt_ARGS

long VolPeekMem(RPC2_Handle cid, RPC2_String address, RPC2_BoundedBS *buf);
long S_VolPeekMem(RPC2_Handle cid, RPC2_String address, RPC2_BoundedBS *buf);
#define VolPeekMem_OP	36
extern ARG VolPeekMem_ARGS[];
#define VolPeekMem_PTR	VolPeekMem_ARGS

long VolPokeMem(RPC2_Handle cid, RPC2_String address, RPC2_CountedBS *buf);
long S_VolPokeMem(RPC2_Handle cid, RPC2_String address, RPC2_CountedBS *buf);
#define VolPokeMem_OP	37
extern ARG VolPokeMem_ARGS[];
#define VolPokeMem_PTR	VolPokeMem_ARGS

long VolSwapmalloc(RPC2_Handle cid);
long S_VolSwapmalloc(RPC2_Handle cid);
#define VolSwapmalloc_OP	38
extern ARG VolSwapmalloc_ARGS[];
#define VolSwapmalloc_PTR	VolSwapmalloc_ARGS

long NewVolMarkAsAncient(RPC2_Handle cid, VolumeId backupId);
long S_NewVolMarkAsAncient(RPC2_Handle cid, VolumeId backupId);
#define NewVolMarkAsAncient_OP	40
extern ARG NewVolMarkAsAncient_ARGS[];
#define NewVolMarkAsAncient_PTR	NewVolMarkAsAncient_ARGS

long GetVolumeList(RPC2_Handle cid, SE_Descriptor *sed);
long S_GetVolumeList(RPC2_Handle cid, SE_Descriptor *sed);
#define GetVolumeList_OP	41
extern ARG GetVolumeList_ARGS[];
#define GetVolumeList_PTR	GetVolumeList_ARGS

long VolDumpVRDB(RPC2_Handle cid, RPC2_String infile);
long S_VolDumpVRDB(RPC2_Handle cid, RPC2_String infile);
#define VolDumpVRDB_OP	42
extern ARG VolDumpVRDB_ARGS[];
#define VolDumpVRDB_PTR	VolDumpVRDB_ARGS

#ifdef __cplusplus
}
#endif
#define volUtilOPARRAYSIZE 43

extern CallCountEntry volUtil_CallCount[];

extern MultiCallEntry volUtil_MultiCall[];

extern MultiStubWork volUtil_MultiStubWork[];

extern long volUtil_ElapseSwitch;

extern long volUtil_EnqueueRequest;

#endif /* _VOLUTIL_ */
